#ifndef APPLICATION_H
#define APPLICATION_H

#include <fstream>
#include <iostream>
#include <time.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <limits.h>
#include <vector>
#include <deque>
#include <list>
#include <set>
#include <fstream>
#include <stdio.h>
#include <iomanip>



using namespace std ;

//ALGORITHM CONSTANTS
const int NUMBEROFSLOTS = 45;
const int NUMDAYS = 5;
const int SLOTSPERDAY = 9;
const int LASTSLOTINDEX = SLOTSPERDAY-1;
const int WHITE = 0;
const int GREY = 1;
const int BLACK = 2;
const int NIL = INT_MIN;

//ALIASES USED WITH THE ALGORITHM
typedef std::vector<int> IntVector;
typedef std::vector<double> DoubleVector;
typedef std::vector<bool> BoolVector;
typedef std::deque<int> IntQueue;
typedef std::set<int> IntSet;
typedef std::vector<IntVector> TwoDIntVector;
typedef std::vector<BoolVector> TwoDBoolVector;

struct TTAndUnplaced
{
	TwoDIntVector TT;
	IntVector Unplaced;
};

void outputTimAnswerFile(TTAndUnplaced &theSolution, char *filename, int seed);

int calcDistanceToFeasibility(TTAndUnplaced &theSolution);

#include "readinputandmakematricies.h"
#include "initsolgenerator.h"
#include "checkfeas.h"
#include "partialcol.h"
#include "sa-intermediaryfunctions.h"
#include "safunctions.h"



#endif //APPLICATION_H
