#ifndef INITSOLGENERATOR_H
#define INITSOLGENERATOR_H

#include "application.h"

//-------------------------------------------------------------------
TTAndUnplaced generateNewSolution();
//This is used when we want to generate a solution. 

int select_place(int event, bool** event_place, TTAndUnplaced &theSolution, int *numEvsThatCanGoInPlace);
//Works out which place to select for 'event'.

int chooseEventWithMostConflicts(IntVector the_list, int *totalNumConflicts);

int chooseElWithMostFullSlot(IntVector the_list, TTAndUnplaced &theSolution);
//Rather like the bin packing heuristic - we favour a place for the event in a slot which is 
//as full as possible. 

int select_event(int* numPossPlace);

void updateMatricies(bool **eventPlace, int *numPossPlace, int x, int y, int &eventsWithPlacesLeft, int *numEvsThatCanGoInPlace, TwoDIntVector &beforePrec);
//This procedure updates the eventPlace matrix and numPossPlace array in accordance with the
//event that has just been placed. 

#endif //INITSOLGENERATOR_H
