#ifndef SA_SAFUNCTIONS_H
#define SA_SAFUNCTIONS_H

#include "application.h"


int stuDayCost(int day, int theStudent, bool **studentavailability);
//works out the cost of theStudent's day

int totalCost(int a[], int length);
//simply adds up all the integers in a and returns the total (used with delta-evaluation)

//*******************FUNCTIONS FOR SA-PHASE 2********************************************
void doSAPhase2(int &softCost, int &dToF, clock_t &Part3ClockFinish, TTAndUnplaced &theSolution, 
				bool **studentavailability, int **stuDayCosts, int *dayCosts, double SAEndTemp, int &chainCnt);

void doFeasRandWalk(int &softCost, clock_t &Part3ClockFinish, TTAndUnplaced &theSolution, 
				bool **studentavailability, int **stuDayCosts, int *dayCosts);

void doFeasRandWalkPCol(TTAndUnplaced &theSolution, IntVector &timeslotForEvent, clock_t Part1ClockFinish);
//Used with the partialCol operator (does a random walk as a refresh operator)

#endif // SA_SAFUNCTIONS_H
